=== debian/changelog ===
cminpack (1.3.11-1) unstable; urgency=medium

  [ Alexandre Detiste ]
  * fix Team name
  * trim d/rules with newer & shorter syntax

  [ Ole Streicher ]
  * Switch upstream source to github
  * New upstream version 1.3.11
  * Rediff patches
  * Adjust installation paths and files
  * Don't build single precision and long double libraries
  * Adjust project homepage
  * Simplify d/rules a bit
  * Only run basic test in autopkgtest (Closes: #1121959)
  * Drop old CI patches; we now only do the basic tests
  * Rename d/gitlab-ci.yml to d/salsa-ci.yml

 -- Ole Streicher <olebole@debian.org>  Sun, 04 Jan 2026 13:00:58 +0100

cminpack (1.3.6-7) unstable; urgency=medium

  * Skip more tests failing on arm64 (Closes: #1121959)
  * d/u/metadata: Remove "name" field
  * Push Standards-Version to 4.7.2, no changes needed

 -- Ole Streicher <olebole@debian.org>  Fri, 05 Dec 2025 13:16:29 +0100
