=== debian/control ===
Source: cminpack
Standards-Version: 4.7.2
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Ole Streicher <olebole@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Vcs-Browser: https://salsa.debian.org/science-team/cminpack
Vcs-Git: https://salsa.debian.org/science-team/cminpack.git
Homepage: https://devernay.github.io/cminpack/

Package: libcminpack-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libcminpack1 (= ${binary:Version}),
 ${misc:Depends},
Recommends:
 minpack-dev,
Description: Nonlinear equations and nonlinear least squares problems - development
 Minpack includes software for solving nonlinear equations and nonlinear least
 squares problems. Five algorithmic paths each include a core subroutine and an
 easy-to-use driver. The algorithms proceed either from an analytic
 specification of the Jacobian matrix or directly from the problem functions.
 The paths include facilities for systems of equations with a banded Jacobian
 matrix, for least squares problems with a large amount of data, and for
 checking the consistency of the Jacobian matrix with the functions.
 .
 This is the C re-write of the original fortran minpack implementation.
 .
 This package contains development files needed to build cminpack applications.

Package: libcminpack1
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Nonlinear equations and nonlinear least squares problems - runtime
 Minpack includes software for solving nonlinear equations and nonlinear least
 squares problems. Five algorithmic paths each include a core subroutine and an
 easy-to-use driver. The algorithms proceed either from an analytic
 specification of the Jacobian matrix or directly from the problem functions.
 The paths include facilities for systems of equations with a banded Jacobian
 matrix, for least squares problems with a large amount of data, and for
 checking the consistency of the Jacobian matrix with the functions.
 .
 This is the C re-write of the original fortran minpack implementation.
 .
 This package contains the libraries needed to run cminpack applications.

Package: cminpack-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Description: Nonlinear equations and nonlinear least squares problems (doc)
 Minpack includes software for solving nonlinear equations and nonlinear least
 squares problems. Five algorithmic paths each include a core subroutine and an
 easy-to-use driver. The algorithms proceed either from an analytic
 specification of the Jacobian matrix or directly from the problem functions.
 The paths include facilities for systems of equations with a banded Jacobian
 matrix, for least squares problems with a large amount of data, and for
 checking the consistency of the Jacobian matrix with the functions.
 .
 This is the C re-write of the original fortran minpack implementation.
 .
 This package contains documentation files for cminpack.
