=== debian/watch ===
Version: 5
Template: Github
Owner: devernay
Project: cminpack
